﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class WireframeThumb : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        List<Ektron.Cms.TemplateData> tData = new List<Ektron.Cms.TemplateData>();

        //Uncomment for versions older than 8.6
        //Ektron.Cms.API.Content.Content capi = new Ektron.Cms.API.Content.Content();
        //tData = capi.GetAllTemplates("id").ToList();
        //if (tData != null)
        //{
        //    foreach (var item in tData)
        //    {
        //        if (item.SubType == Ektron.Cms.Common.EkEnumeration.TemplateSubType.Wireframes)
        //        {
        //            templatelist.Items.Add(new ListItem { Text = item.FileName, Value = item.FileName });
        //        }
        //    }
        //}

        //Uncomment for versions newer than 8.6
        Ektron.Cms.Framework.Content.TemplateManager tManager = new Ektron.Cms.Framework.Content.TemplateManager();
        Ektron.Cms.Common.TemplateCriteria criteria = new Ektron.Cms.Common.TemplateCriteria();
        criteria.AddFilter(Ektron.Cms.Common.TemplateDataProperty.Id, Ektron.Cms.Common.CriteriaFilterOperator.GreaterThan, 0);
        criteria.PagingInfo = new Ektron.Cms.PagingInfo(10000);
        tData = tManager.GetList(criteria);
        if (tData != null)
        {
            foreach (var item in tData)
            {
                if (item.SubType == Ektron.Cms.Common.EkEnumeration.TemplateSubType.Wireframes)
                {
                    templatelist.Items.Add(new ListItem { Text = item.FileName, Value = item.FileName });
                }
            }
        }
    }
    protected void genthumb_Click(object sender, EventArgs e)
    {
        try
        {
            Ektron.Cms.TemplateData tData = new Ektron.Cms.TemplateData();
            Ektron.Cms.PageBuilder.TemplateModel tm = new Ektron.Cms.PageBuilder.TemplateModel();
            //Uncomment for versions older than 8.6
            //if (templateid.Value.Length > 0)
            //{
                //Ektron.Cms.API.Content.Content capi = new Ektron.Cms.API.Content.Content();
                //tData = capi.EkContentRef.GetTemplateInfoByID(long.Parse(templateid.Value));
            //}
            
            //Uncomment for versions newer than 8.6
            if (templateid.Value.Length > 0)
            {
                Ektron.Cms.Framework.Content.TemplateManager tManager = new Ektron.Cms.Framework.Content.TemplateManager();
                tData = tManager.GetItem(long.Parse(templateid.Value));
                GenThumbFromTempID(tData);
            }
            else
            {
                GenThumb(templatelist.SelectedValue);
            }
        }
        catch (Exception ex)
        {
            Response.Write("Thumbnail NOT generated successfully<br />" + ex.Message);
        }
    }

    private void GenThumb(string file)
    {
        try
        {
            Ektron.Cms.PageBuilder.TemplateModel tm = new Ektron.Cms.PageBuilder.TemplateModel();
            tm.GenerateThumbnail(templatelist.SelectedValue);
            Response.Write("Thumbnail generated successfully");
        }
        catch (Exception ex)
        {
            Response.Write("Thumbnail NOT generated successfully<br />" + ex.Message);
        }
    }

    private void GenThumbFromTempID(Ektron.Cms.TemplateData tData)
    {
        if (tData != null)
        {
            if (tData.SubType == Ektron.Cms.Common.EkEnumeration.TemplateSubType.Wireframes)
            {
                GenThumb(tData.FileName);
            }
        }
        else
        {
            Response.Write("Could not find the template by id");
        }
    }
}